; The ultimate abstract ZIP
; by gynvael.coldwind//vx
[bits 32]

; Let's make a ZIP! :)

; Note: how to calculate crc-32? easy! just try to unpack the file
;       with commandline unzip, it shows the good crc ;p

; -------------------------------------------------------------------

; Loose file FILE HEADER
; This file has no entry in the Central Directory.
; It will be seen only by stream readers, and never by readers that
; interpret ZIP by the book.


file_loose:
dd 0x04034b50             ; local file header signature     4 bytes  (0x04034b50)
dw 0x000a                 ; version needed to extract       2 bytes  (1.0)
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes  (0 - store)
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0xe82330fb             ; crc-32                          4 bytes
dd file_loose_data_e - file_loose_data_s ; compressed size                 4 bytes
dd file_loose_data_e - file_loose_data_s ; uncompressed size               4 bytes
dw 17                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes

; name
db "readme_Stream.txt"

; extra header would be here

; file data (this is stored, so plaintext)
file_loose_data_s:
db "You are using: *** STREAM TYPE EXTRACTOR ***", 0x0d, 0x0a
db "Stream-type extractors don't exactly follow the ZIP APPNOTE.TXT.", 0x0d, 0x0a
db "There are ZIP files that a stream extractor will fail to extract.", 0x0d, 0x0a
file_loose_data_e:

; -------------------------------------------------------------------

; ZIP STRUCTURE BREAKER to make the stream reader bail out.
; Note: some stream readers may aggressively look for next signature;
;       the next file is made just for them

db "--- STRUCTURE BREAKER ---"

; -------------------------------------------------------------------

; Another loose file FILE HEADER
; As the above one, this file has no entry in the Central Directory.
; It will be only discovered by aggressive stream readers that ignore
; data that is between packets and look for the next file header 
; signature.

; Note: all the other data in this ZIP file is treated as data for this
;       file; this is to make the stream reader ignore the rest of the
;       files

file_loose2:

dd 0x04034b50             ; local file header signature     4 bytes  (0x04034b50)
dw 0x000a                 ; version needed to extract       2 bytes  (1.0)
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes  (0 - store)
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0x437c5871             ; crc-32                          4 bytes
dd end_of_file - file_loose2_data_s ; compressed size                 4 bytes
dd end_of_file - file_loose2_data_s ; uncompressed size               4 bytes
dw 27                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes

; name
db "readme_AggressiveStream.txt"

; extra header would be here

; file data (this is stored, so plaintext)
file_loose2_data_s:
db "You are using: *** AGGRESSIVE STREAM TYPE EXTRACTOR ***", 0x0d, 0x0a
db "Your stream type extractor didn't stop on encountering data placed", 0x0d, 0x0a
db "between files, but aggressively seeked the next File Header.", 0x0d, 0x0a

db 0x0d, 0x0a
db 0x0d, 0x0a
db "Ignore the data after this line.", 0x0d, 0x0a
db "-----------------------------------------------------------------", 0x0d, 0x0a

; All the other data stuff in the file is considered data, just to make the
; stream reader ignore it.

; -------------------------------------------------------------------

; START file Local File Hedaer
file_start:
dd 0x04034b50             ; local file header signature     4 bytes  (0x04034b50)
dw 0x000a                 ; version needed to extract       2 bytes  (1.0)
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes  (0 - store)
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0x206ac50a             ; crc-32                          4 bytes
dd file_start_data_e - file_start_data_s ; compressed size                 4 bytes
dd file_start_data_e - file_start_data_s  ; uncompressed size               4 bytes
dw 21                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes

; name
db "readme_StartFirst.txt"

; extra header would be here

; file data (this is stored, so plaintext)
file_start_data_s:
db "You are using: *** START-FIRST TYPE EXTRACTOR ***", 0x0d, 0x0a
db "Start-first extractors look for the End-of-central-directory record", 0x0d, 0x0a
db "first at the start of possible area where it would be placed.", 0x0d, 0x0a
db "They are quite uncommon, since it's more optimal to look at the end first.", 0x0d, 0x0a
file_start_data_e:


; -------------------------------------------------------------------

central_directory_start_s:

; Central directory entries
dd 0x02014b50             ; central file header signature   4 bytes  (0x02014b50)
dw 0x031e                 ; version made by                 2 bytes
dw 0x000a                 ; version needed to extract       2 bytes
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0x206ac50a             ; crc-32                          4 bytes
dd file_start_data_e - file_start_data_s ; compressed size                 4 bytes
dd file_start_data_e - file_start_data_s ; uncompressed size               4 bytes
dw 21                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes
dw 0                      ; file comment length             2 bytes
dw 0                      ; disk number start               2 bytes
dw 0                      ; internal file attributes        2 bytes
dd 0                      ; external file attributes        4 bytes
dd file_start             ; relative offset of local header 4 bytes

; name
db "readme_StartFirst.txt"

; extra header would be here

; comment would be here

central_directory_start_e:

; -------------------------------------------------------------------
;  End of central directory record:

dd 0x06054b50             ; end of central dir signature    4 bytes  (0x06054b50)
dw 0                      ; number of this disk             2 bytes
dw 0                      ; number of the disk with the
                          ; start of the central directory  2 bytes
dw 1                      ; total number of entries in the
                          ; central directory on this disk  2 bytes
dw 1                      ; total number of entries in
                          ; the central directory           2 bytes
dd central_directory_start_e - central_directory_start_s
                          ; size of the central directory   4 bytes
dd central_directory_start_s ; offset of start of central
                          ; directory with respect to
                          ; the starting disk number        4 bytes
dw end_of_file - eocd_start_e ; .ZIP file comment length        2 bytes

; .ZIP file comment       (variable size)
eocd_start_e:

db 0 ; NUL-byte to make it not print trash as comment.


; -------------------------------------------------------------------

; END file Local File Hedaer
file_end:
dd 0x04034b50             ; local file header signature     4 bytes  (0x04034b50)
dw 0x000a                 ; version needed to extract       2 bytes  (1.0)
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes  (0 - store)
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0x04e2563f             ; crc-32                          4 bytes
dd file_end_data_e - file_end_data_s ; compressed size                 4 bytes
dd file_end_data_e - file_end_data_s  ; uncompressed size               4 bytes
dw 19                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes

; name
db "readme_EndFirst.txt"

; extra header would be here

; file data (this is stored, so plaintext)
file_end_data_s:
db "You are using: *** END-FIRST TYPE EXTRACTOR ***", 0x0d, 0x0a
db "The End-first extractors are the most common ones. They look for the", 0x0d, 0x0a
db "end-of-central-directory header at the end of the file, which is the", 0x0d, 0x0a
db "most probable place the header is found.", 0x0d, 0x0a
file_end_data_e:


; -------------------------------------------------------------------

central_directory_end_s:

; Central directory entries
dd 0x02014b50             ; central file header signature   4 bytes  (0x02014b50)
dw 0x031e                 ; version made by                 2 bytes
dw 0x000a                 ; version needed to extract       2 bytes
dw 0                      ; general purpose bit flag        2 bytes
dw 0                      ; compression method              2 bytes
dw 0                      ; last mod file time              2 bytes
dw 0                      ; last mod file date              2 bytes
dd 0x04e2563f             ; crc-32                          4 bytes
dd file_end_data_e - file_end_data_s ; compressed size                 4 bytes
dd file_end_data_e - file_end_data_s ; uncompressed size               4 bytes
dw 19                     ; file name length                2 bytes
dw 0                      ; extra field length              2 bytes
dw 0                      ; file comment length             2 bytes
dw 0                      ; disk number start               2 bytes
dw 0                      ; internal file attributes        2 bytes
dd 0                      ; external file attributes        4 bytes
dd file_end               ; relative offset of local header 4 bytes

; name
db "readme_EndFirst.txt"

; extra header would be here

; comment would be here

central_directory_end_e:

; -------------------------------------------------------------------
;  End of central directory record:

dd 0x06054b50             ; end of central dir signature    4 bytes  (0x06054b50)
dw 0                      ; number of this disk             2 bytes
dw 0                      ; number of the disk with the
                          ; start of the central directory  2 bytes
dw 1                      ; total number of entries in the
                          ; central directory on this disk  2 bytes
dw 1                      ; total number of entries in
                          ; the central directory           2 bytes
dd central_directory_end_e - central_directory_end_s
                          ; size of the central directory   4 bytes
dd central_directory_end_s ; offset of start of central
                          ; directory with respect to
                          ; the starting disk number        4 bytes
dw 0                      ; .ZIP file comment length        2 bytes

; .ZIP file comment       (variable size)



; -------------------------------------------------------------------
; End of file.
end_of_file:

; vim: syntax=nasm
